<?php
/**
 $('#slider').nivoSlider({
	effect:'random', // Efecto de transicin: 'fold,fade,sliceDown'
	slices:15, // Para animaciones 'slice'
	boxCols: 8, // Para animaciones 'box'
	boxRows: 4, // Para animaciones 'box'
	animSpeed:500, // Velocidad de la transicin
	pauseTime:3000, // Cunto tiempo en milisegundos se visualiza una imagen
	startSlide:0, // Imagen de comienzo (empezando por cero)
	directionNav:true, // Si queremos que aparezcan controles para siguiente y anterior
	directionNavHide:true, // Slo cuando el cursor se sita sobre el componente
							   se visualizar la navegacin
	controlNav:true, // 1,2,3... navegacin
	controlNavThumbs:false, // Usar miniaturas para el control de la navegacin
	controlNavThumbsFromRel:false, // Usar imagen rel para miniaturas
	controlNavThumbsSearch: '.jpg', // Reemplazar este patrn del nombre de la imagen...
	controlNavThumbsReplace: '_thumb.jpg', // ...con esto para las imgenes miniatura
	keyboardNav:true, // Usar las flechas izquierda y derecha para navegacin
	pauseOnHover:true, // Parar navegacin al pasar el ratn sobre el componente
	manualAdvance:false, // Forzar transiciones manuales
	captionOpacity:0.8, // Opacidad para los caption o ttulos de las imgenes
	prevText: 'Ant', // Texto de navegacin hacia la izquierda
	nextText: 'Sig', // Texto de navegacin hacia la derecha
	beforeChange: function(){}, // Funcin que se ejecuta antes de una transicin
	afterChange: function(){}, // Funcin que se ejecuta despus de una transicin
	slideshowEnd: function(){}, // Funcin que se ejecuta despus de que todas
								   las imgenes se han mostrado
	lastSlide: function(){}, // Funcin que se ejecuta cuando la ltima imagen se visualiza
	afterLoad: function(){} // Funcin que se ejecuta cuando se carga el componente
});
 */

/**
 * Nivo Slider images
 * 
 * @autor Javier Lema <touzas@gmail.com>
 */
class TSlider extends CWidget {
	
	var $images;
	var $width;
	var $height;
	var $alt;
	var $id;
	
	public function init(){		
		
		$dir = dirname(__FILE__).DIRECTORY_SEPARATOR.'assets';
		$baseUrl = Yii::app()->getAssetManager()->publish($dir);

		$cs = Yii::app()->getClientScript();
		$cs->registerScriptFile($baseUrl.'/jquery.nivo.slider.js', CClientScript::POS_END);
		$cs->registerCssFile($baseUrl.'/nivo-slider.css', 'screen');
		$cs->registerCssFile($baseUrl.'/default.css');
		
		if ($this->id == '')
			$this->id = 'Slider'.date('YmdHis');
		
		$cs->registerScript($this->id, "
			$('#".$this->id."').nivoSlider({
				directionNav: false,
				directionNavHide:false,
				controlNav:false,
				animSpeed:500,
				pauseTime:3000,
			}); 
		", CClientScript::POS_LOAD);				
	}
	
	private function parse2stdClass($array){ 		 
		$tmp = new stdClass();
		foreach($array as $k => $v){
			$tmp->{$k} = $v;			
		}
		return $tmp;
        }	
	
	public function run(){
		echo '
			<div id="'.$this->id.'" class="slider" style="width:'.$this->width.'px; height: '.$this->height.'px">
		';
		if (is_array($this->images)){
			foreach($this->images as $img){
				$img = $this->parse2stdClass($img);				
				if (isset($img->url))
					echo CHtml::link(CHtml::image($img->image, $this->alt, array('width' => $this->width, 'height' => $this->height)), $img->url);
				else
					echo CHtml::image($img->image, $this->alt, array('width' => $this->width, 'height' => $this->height));
			}
		}								
		echo '
			</div>
		';
	}
}
?>
